diff -rupN newpd/pd-0.45-0/doc/5.reference/all_about_audio_settings.pd pd-0.45-0/doc/5.reference/all_about_audio_settings.pd
--- newpd/pd-0.45-0/doc/5.reference/all_about_audio_settings.pd	1969-12-31 19:00:00.000000000 -0500
+++ pd-0.45-0/doc/5.reference/all_about_audio_settings.pd	2013-08-27 12:37:35.778359565 -0400
@@ -0,0 +1,53 @@
+#N canvas 301 148 448 507 10;
+#X obj 1 1 cnv 15 445 20 empty \$0-pddp.cnv.header Audio_Settings 20
+10 1 18 -261106 -33289 0;
+#X obj 407 2 pddp/pddplink http://puredata.info/dev/pddp -text pddp
+;
+#X obj 1 485 cnv 15 445 20 empty \$0-pddp.cnv.footer empty 20 12 0
+14 -233017 -33289 0;
+#N canvas 274 224 494 284 META 0;
+#X text 12 65 LIBRARY PDDP;
+#X text 12 5 GENRE all_about_pd;
+#X text 12 25 KEYWORDS help;
+#X text 12 45 DESCRIPTION description of the audio preferences dialog
+;
+#X text 12 85 HELP_PATCH_AUTHORS Jonathan Wilkes \, Pd-ext 0.44.;
+#X restore 382 487 pd META;
+#X obj 6 487 pddp/pddplink all_about.pd -text All About Pd;
+#N canvas 331 442 428 183 References 0;
+#X obj 1 1 cnv 15 425 20 empty \$0-pddp.cnv.subheading empty 3 12 0
+14 -261106 -33289 0;
+#X text 7 2 Audio Settings;
+#X restore 103 487 pd References;
+#X text 19 26 Audio API;
+#X text 19 26 _________;
+#X text 19 106 Not all operating systems have the same audio APIs available
+\, and some like Jack Audio Server may need to be installed in order
+to use them. Check your operating system documentation to see what
+the common audio API is.;
+#X text 19 226 Settings;
+#X text 19 226 ________;
+#X text 19 246 Sample rate - for incoming and outgoing audio;
+#X text 19 266 Delay - delay between the time Pd receives audio data
+and the time it sends it to the API.;
+#X text 19 346 Note: Some APIs like the Jack Audio Server have their
+own interface for setting the latency.;
+#X text 19 296 Block size - number of samples to send to the API in
+each block.;
+#X text 19 326 Use callbacks - use callbacks???;
+#X text 19 46 This is the software with which Pd sends and receives
+the audio signals. The audio API is responsible for communicating with
+the operating system (or other software) which ultimately communicates
+with the audio hardware.;
+#X text 19 166 Use multiple devices - with some audio APIs like ALSA
+(available on most GNU/Linux distros) you can specify up to four devices
+within Pd. Some APIs \, like the Jack Audio Server \, have their own
+interface to specify device settings.;
+#X text 19 376 Devices;
+#X text 19 376 _______;
+#X text 19 426 _______;
+#X text 19 391 Choose your input/output devices \, as well as the number
+of channels for each device.;
+#X text 19 426 Connect;
+#X text 19 441 Connect to the audio device(s) with the settings you
+gave above. When you connect \, Pd saves your audio preferences.;
diff -rupN newpd/pd-0.45-0/doc/5.reference/all_about_gui_settings.pd pd-0.45-0/doc/5.reference/all_about_gui_settings.pd
--- newpd/pd-0.45-0/doc/5.reference/all_about_gui_settings.pd	1969-12-31 19:00:00.000000000 -0500
+++ pd-0.45-0/doc/5.reference/all_about_gui_settings.pd	2013-08-27 12:37:35.782359482 -0400
@@ -0,0 +1,42 @@
+#N canvas 242 107 448 427 10;
+#X obj 1 1 cnv 15 445 20 empty \$0-pddp.cnv.header GUI_Settings 20
+10 1 18 -261106 -33289 0;
+#X obj 407 2 pddp/pddplink http://puredata.info/dev/pddp -text pddp
+;
+#X obj 1 405 cnv 15 445 20 empty \$0-pddp.cnv.footer empty 20 12 0
+14 -233017 -33289 0;
+#N canvas 274 224 494 284 META 0;
+#X text 12 65 LIBRARY PDDP;
+#X text 12 5 GENRE all_about_pd;
+#X text 12 85 HELP_PATCH_AUTHORS Jonathan Wilkes \, Pd-ext 0.44.;
+#X text 12 45 DESCRIPTION description of the GUI preferences dialog
+;
+#X text 12 25 KEYWORDS help gui;
+#X restore 382 407 pd META;
+#X obj 6 407 pddp/pddplink all_about.pd -text All About Pd;
+#N canvas 331 442 428 183 References 0;
+#X obj 1 1 cnv 15 425 20 empty \$0-pddp.cnv.subheading empty 3 12 0
+14 -261106 -33289 0;
+#X text 7 2 GUI Settings;
+#X restore 103 407 pd References;
+#X text 19 26 Presets;
+#X text 19 26 _______;
+#X text 19 46 GUI presets will change the look of Pd canvases and the
+objects on them which don't already have colors specified by the user.
+(E.g. \, object boxes \, xlets \, comments \, canvas backgrounds \,
+but not iemgui backgrounds or labels.);
+#X text 19 106 Choose a preset from the dropdown list. When you select
+a new preset all open patches will get changed to the colors of that
+preset \, in addition to all patches opened afterward. Note: selected
+objects don't immediately get updated-- you have to clear the selection
+and reselect to see the change.;
+#X text 19 196 Colors;
+#X text 19 196 ______;
+#X text 19 211 Click the button with the colorswatch to change the
+color for the corresponding attribute. Once you choose a color each
+open canvas will immediately be updated \, and any canvas you open
+after that will inherit the color you chose.;
+#X text 19 281 Note: it is very easy to obscure Pd patches by choosing
+colors that are difficult for others to read. If you make screenshots
+of patches to show on the web or post to a mailinglist \, use one of
+the default non-inverted presets.;
diff -rupN newpd/pd-0.45-0/doc/5.reference/all_about_midi_settings.pd pd-0.45-0/doc/5.reference/all_about_midi_settings.pd
--- newpd/pd-0.45-0/doc/5.reference/all_about_midi_settings.pd	1969-12-31 19:00:00.000000000 -0500
+++ pd-0.45-0/doc/5.reference/all_about_midi_settings.pd	2013-08-27 12:37:35.786359398 -0400
@@ -0,0 +1,47 @@
+#N canvas 242 107 448 427 10;
+#X obj 1 1 cnv 15 445 20 empty \$0-pddp.cnv.header MIDI_Settings 20
+10 1 18 -261106 -33289 0;
+#X obj 407 2 pddp/pddplink http://puredata.info/dev/pddp -text pddp
+;
+#X obj 1 405 cnv 15 445 20 empty \$0-pddp.cnv.footer empty 20 12 0
+14 -233017 -33289 0;
+#N canvas 274 224 494 284 META 0;
+#X text 12 65 LIBRARY PDDP;
+#X text 12 5 GENRE all_about_pd;
+#X text 12 85 HELP_PATCH_AUTHORS Jonathan Wilkes \, Pd-ext 0.44.;
+#X text 12 45 DESCRIPTION description of the MIDI preferences dialog
+;
+#X text 12 25 KEYWORDS help midi;
+#X restore 382 407 pd META;
+#X obj 6 407 pddp/pddplink all_about.pd -text All About Pd;
+#N canvas 331 442 428 183 References 0;
+#X obj 1 1 cnv 15 425 20 empty \$0-pddp.cnv.subheading empty 3 12 0
+14 -261106 -33289 0;
+#X text 7 2 Audio Settings;
+#X restore 103 407 pd References;
+#X text 19 266 Devices;
+#X text 19 266 _______;
+#X text 19 316 _______;
+#X text 19 316 Connect;
+#X text 19 26 MIDI Api;
+#X text 19 26 ________;
+#X text 19 46 This is the software with which Pd sends and receives
+the MIDI data. The MIDI API is responsible for communicating with the
+operating system which ultimately communicates with the MIDI hardware.
+;
+#X text 19 106 Not all operating systems have the same MIDI APIs available
+\, and some devices require software to be installed before using them.
+Check your operating system and device documentation to learn how to
+set up the device.;
+#X text 19 166 Use multiple devices - with some MIDI APIs you can specify
+up to four devices from within Pd. Some MIDI devices have their own
+software interface to change settings specific to the device. Check
+your hardware documentation for more info. Note: if there is only one
+device (or if your specific setup doesn't allow multiple devices to
+be specified from within Pd) then this button will be disabled.;
+#X text 19 281 Choose your input/output devices \, as well as the number
+of channels for each device.;
+#X text 19 331 Connect to the audio device(s) with the settings you
+gave above. When you connect \, Pd saves your MIDI preferences \, so
+when you close Pd and open it again these settings will automatically
+be loaded.;
diff -rupN newpd/pd-0.45-0/src/g_all_guis.c pd-0.45-0/src/g_all_guis.c
--- newpd/pd-0.45-0/src/g_all_guis.c	2013-08-07 16:29:37.000000000 -0400
+++ pd-0.45-0/src/g_all_guis.c	2013-08-27 12:37:35.786359398 -0400
@@ -123,6 +123,12 @@ char *iemgui_vu_scale_str[]=
 
 /*------------------ global functions -------------------------*/
 
+char *iemgui_intcoltostring(int col)
+{
+    static char buf[MAXPDSTRING];
+    sprintf(buf, "#%6.6x", col);
+    return (buf);
+}
 
 int iemgui_clip_size(int size)
 {
diff -rupN newpd/pd-0.45-0/src/g_all_guis.h pd-0.45-0/src/g_all_guis.h
--- newpd/pd-0.45-0/src/g_all_guis.h	2013-08-07 16:29:37.000000000 -0400
+++ pd-0.45-0/src/g_all_guis.h	2013-08-27 12:37:35.786359398 -0400
@@ -37,8 +37,8 @@
 #define IEM_GUI_COLNR_D_BLUE         28
 #define IEM_GUI_COLNR_D_MAGENTA      29
 
-#define IEM_GUI_COLOR_SELECTED       255
-#define IEM_GUI_COLOR_NORMAL         0
+#define IEM_GUI_COLOR_SELECTED       "$::pd_colors(selected)"
+#define IEM_GUI_COLOR_NORMAL         "$::pd_colors(iemgui_border)"
 
 #define IEM_GUI_MAX_COLOR            30
 
@@ -283,6 +283,7 @@ extern int iemgui_vu_col[];
 extern char *iemgui_vu_scale_str[];
 
 EXTERN int iemgui_clip_size(int size);
+EXTERN char *iemgui_intcoltostring(int col);
 EXTERN int iemgui_clip_font(int size);
 EXTERN int iemgui_modulo_color(int col);
 EXTERN t_symbol *iemgui_unique2dollarzero(t_symbol *s, int unique_num, int and_unique_flag);
diff -rupN newpd/pd-0.45-0/src/g_bang.c pd-0.45-0/src/g_bang.c
--- newpd/pd-0.45-0/src/g_bang.c	2013-08-07 16:29:37.000000000 -0400
+++ pd-0.45-0/src/g_bang.c	2013-08-27 12:37:35.790359315 -0400
@@ -46,16 +46,18 @@ void bng_draw_new(t_bng *x, t_glist *gli
     int ypos=text_ypix(&x->x_gui.x_obj, glist);
     t_canvas *canvas=glist_getcanvas(glist);
 
-    sys_vgui(".x%lx.c create rectangle %d %d %d %d -fill #%6.6x -tags %lxBASE\n",
+    sys_vgui(".x%lx.c create rectangle %d %d %d %d -fill #%6.6x \
+        -outline $::pd_colors(iemgui_border) -tags {%lxBASE iemgui border}\n",
              canvas, xpos, ypos,
              xpos + x->x_gui.x_w, ypos + x->x_gui.x_h,
              x->x_gui.x_bcol, x);
-    sys_vgui(".x%lx.c create oval %d %d %d %d -fill #%6.6x -tags %lxBUT\n",
+    sys_vgui(".x%lx.c create oval %d %d %d %d -fill #%6.6x \
+        -outline $::pd_colors(iemgui_border) -tags {%lxBUT iemgui border}\n",
              canvas, xpos+1, ypos+1,
              xpos + x->x_gui.x_w-1, ypos + x->x_gui.x_h-1,
              x->x_flashed?x->x_gui.x_fcol:x->x_gui.x_bcol, x);
     sys_vgui(".x%lx.c create text %d %d -text {%s} -anchor w \
-             -font {{%s} -%d %s} -fill #%6.6x -tags [list %lxLABEL label text]\n",
+             -font {{%s} -%d %s} -fill #%6.6x -tags [list %lxLABEL iemgui label text]\n",
              canvas, xpos+x->x_gui.x_ldx,
              ypos+x->x_gui.x_ldy,
              strcmp(x->x_gui.x_lab->s_name, "empty")?x->x_gui.x_lab->s_name:"",
@@ -84,7 +86,8 @@ void bng_draw_move(t_bng *x, t_glist *gl
     sys_vgui(".x%lx.c coords %lxBUT %d %d %d %d\n",
              canvas, x, xpos+1,ypos+1,
              xpos + x->x_gui.x_w-1, ypos + x->x_gui.x_h-1);
-    sys_vgui(".x%lx.c itemconfigure %lxBUT -fill #%6.6x\n", canvas, x,
+    sys_vgui(".x%lx.c itemconfigure %lxBUT -fill #%6.6x \
+        -outline $::pd_colors(iemgui_border)\n", canvas, x,
              x->x_flashed?x->x_gui.x_fcol:x->x_gui.x_bcol);
     sys_vgui(".x%lx.c coords %lxLABEL %d %d\n",
              canvas, x, xpos+x->x_gui.x_ldx, ypos+x->x_gui.x_ldy);
@@ -116,12 +119,14 @@ void bng_draw_config(t_bng* x, t_glist*
 {
     t_canvas *canvas=glist_getcanvas(glist);
 
-    sys_vgui(".x%lx.c itemconfigure %lxLABEL -font {{%s} -%d %s} -fill #%6.6x -text {%s} \n",
+    sys_vgui(".x%lx.c itemconfigure %lxLABEL -font {{%s} -%d %s} -fill %s -text {%s} \n",
              canvas, x, x->x_gui.x_font, x->x_gui.x_fontsize, sys_fontweight,
-             x->x_gui.x_fsf.x_selected?IEM_GUI_COLOR_SELECTED:x->x_gui.x_lcol,
+             x->x_gui.x_fsf.x_selected?IEM_GUI_COLOR_SELECTED:iemgui_intcoltostring(x->x_gui.x_lcol),
              strcmp(x->x_gui.x_lab->s_name, "empty")?x->x_gui.x_lab->s_name:"");
-    sys_vgui(".x%lx.c itemconfigure %lxBASE -fill #%6.6x\n", canvas, x, x->x_gui.x_bcol);
-    sys_vgui(".x%lx.c itemconfigure %lxBUT -fill #%6.6x\n", canvas, x,
+    sys_vgui(".x%lx.c itemconfigure %lxBASE -fill #%6.6x \
+        -outline $::pd_colors(iemgui_border)\n", canvas, x, x->x_gui.x_bcol);
+    sys_vgui(".x%lx.c itemconfigure %lxBUT \
+        -outline $::pd_colors(iemgui_border) -fill #%6.6x\n", canvas, x,
              x->x_flashed?x->x_gui.x_fcol:x->x_gui.x_bcol);
 }
 
@@ -152,14 +157,14 @@ void bng_draw_select(t_bng* x, t_glist*
 
     if(x->x_gui.x_fsf.x_selected)
     {
-        sys_vgui(".x%lx.c itemconfigure %lxBASE -outline #%6.6x\n", canvas, x, IEM_GUI_COLOR_SELECTED);
-        sys_vgui(".x%lx.c itemconfigure %lxBUT -outline #%6.6x\n", canvas, x, IEM_GUI_COLOR_SELECTED);
-        sys_vgui(".x%lx.c itemconfigure %lxLABEL -fill #%6.6x\n", canvas, x, IEM_GUI_COLOR_SELECTED);
+        sys_vgui(".x%lx.c itemconfigure %lxBASE -outline %s\n", canvas, x, IEM_GUI_COLOR_SELECTED);
+        sys_vgui(".x%lx.c itemconfigure %lxBUT -outline %s\n", canvas, x, IEM_GUI_COLOR_SELECTED);
+        sys_vgui(".x%lx.c itemconfigure %lxLABEL -fill %s\n", canvas, x, IEM_GUI_COLOR_SELECTED);
     }
     else
     {
-        sys_vgui(".x%lx.c itemconfigure %lxBASE -outline #%6.6x\n", canvas, x, IEM_GUI_COLOR_NORMAL);
-        sys_vgui(".x%lx.c itemconfigure %lxBUT -outline #%6.6x\n", canvas, x, IEM_GUI_COLOR_NORMAL);
+        sys_vgui(".x%lx.c itemconfigure %lxBASE -outline %s\n", canvas, x, IEM_GUI_COLOR_NORMAL);
+        sys_vgui(".x%lx.c itemconfigure %lxBUT -outline %s\n", canvas, x, IEM_GUI_COLOR_NORMAL);
         sys_vgui(".x%lx.c itemconfigure %lxLABEL -fill #%6.6x\n", canvas, x, x->x_gui.x_lcol);
     }
 }
diff -rupN newpd/pd-0.45-0/src/g_canvas.c pd-0.45-0/src/g_canvas.c
--- newpd/pd-0.45-0/src/g_canvas.c	2013-08-18 21:38:22.000000000 -0400
+++ pd-0.45-0/src/g_canvas.c	2013-08-27 12:37:35.790359315 -0400
@@ -761,11 +761,16 @@ static void canvas_drawlines(t_canvas *x
     {
         linetraverser_start(&t, x);
         while (oc = linetraverser_next(&t))
-            sys_vgui(".x%lx.c create line %d %d %d %d -width %d -tags [list l%lx cord]\n",
-                    glist_getcanvas(x),
-                        t.tr_lx1, t.tr_ly1, t.tr_lx2, t.tr_ly2, 
-                            (outlet_getsymbol(t.tr_outlet) == &s_signal ? 2:1),
-                                oc);
+            sys_vgui(".x%lx.c create line %d %d %d %d -width %d \
+                -fill $::pd_colors(%s) -tags [list l%lx %s cord]\n",
+                glist_getcanvas(x),
+                t.tr_lx1, t.tr_ly1, t.tr_lx2, t.tr_ly2, 
+                (outlet_getsymbol(t.tr_outlet) == &s_signal ? 2:1),
+                (outlet_getsymbol(t.tr_outlet) == &s_signal ?
+                    "cord_signal" : "cord_control"),
+                oc,
+               (outlet_getsymbol(t.tr_outlet) == &s_signal ?
+                   "signal" : "control"));
     }
 }
 
diff -rupN newpd/pd-0.45-0/src/g_editor.c pd-0.45-0/src/g_editor.c
--- newpd/pd-0.45-0/src/g_editor.c	2013-08-09 18:17:07.000000000 -0400
+++ pd-0.45-0/src/g_editor.c	2013-08-27 12:37:35.794359232 -0400
@@ -128,7 +128,7 @@ void glist_selectline(t_glist *x, t_outc
         x->gl_editor->e_selectline_index2 = index2;
         x->gl_editor->e_selectline_inno = inno;
         x->gl_editor->e_selectline_tag = oc;
-        sys_vgui(".x%lx.c itemconfigure l%lx -fill blue\n",
+        sys_vgui(".x%lx.c itemconfigure l%lx -fill $::pd_colors(selected)\n",
             x, x->gl_editor->e_selectline_tag);
     }    
 }
@@ -138,8 +138,13 @@ void glist_deselectline(t_glist *x)
     if (x->gl_editor)
     {
         x->gl_editor->e_selectedline = 0;
-        sys_vgui(".x%lx.c itemconfigure l%lx -fill black\n",
-            x, x->gl_editor->e_selectline_tag);
+        /* OMG the following is ugly! If there's a way to tell signal cords
+        from control cords here in c then that would be preferable... */
+        sys_vgui(".x%lx.c itemconfigure l%lx -fill \
+            $::pd_colors([lindex {cord_signal cord_control} \
+            [expr {[lsearch -exact [.x%lx.c gettags l%lx] signal] == -1}]])\n",
+                x, x->gl_editor->e_selectline_tag,
+                x, x->gl_editor->e_selectline_tag);
     }    
 }
 
@@ -1349,10 +1354,11 @@ void canvas_doclick(t_canvas *x, int xpo
                         x->gl_editor->e_onmotion = MA_CONNECT;
                         x->gl_editor->e_xwas = xpos;
                         x->gl_editor->e_ywas = ypos;
-                        sys_vgui(
-                          ".x%lx.c create line %d %d %d %d -width %d -tags x\n",
-                                x, xpos, ypos, xpos, ypos,
-                                    (issignal ? 2 : 1));
+                        sys_vgui(".x%lx.c create line %d %d %d %d -width %d \
+                            -fill $::pd_colors(%s) -tags x\n",
+                            x, xpos, ypos, xpos, ypos,
+                            (issignal ? 2 : 1),
+                            (issignal ? "cord_signal" : "cord_control"));
                     }                                   
                     else canvas_setcursor(x, CURSOR_EDITMODE_CONNECT);
                 }
@@ -1434,7 +1440,8 @@ void canvas_doclick(t_canvas *x, int xpo
     if (doit)
     {
         if (!shiftmod) glist_noselect(x);
-        sys_vgui(".x%lx.c create rectangle %d %d %d %d -tags x\n",
+        sys_vgui(".x%lx.c create rectangle %d %d %d %d \
+            -outline $::pd_colors(selection_rectangle) -tags x\n",
               x, xpos, ypos, xpos, ypos);
         x->gl_editor->e_xwas = xpos;
         x->gl_editor->e_ywas = ypos;
@@ -1534,10 +1541,14 @@ void canvas_doconnect(t_canvas *x, int x
                         ((x22-x21-IOWIDTH) * closest2)/(ninlet2-1) : 0)
                             + IOMIDDLE;
                 ly2 = y21;
-                sys_vgui(".x%lx.c create line %d %d %d %d -width %d -tags [list l%lx cord]\n",
-                    glist_getcanvas(x),
-                        lx1, ly1, lx2, ly2,
-                            (obj_issignaloutlet(ob1, closest1) ? 2 : 1), oc);
+                sys_vgui(".x%lx.c create line %d %d %d %d -width %d \
+                    -fill $::pd_colors(%s) -tags [list l%lx %s cord]\n",
+                    glist_getcanvas(x), lx1, ly1, lx2, ly2,
+                    (obj_issignaloutlet(ob1, closest1) ? 2 : 1),
+                    (obj_issignaloutlet(ob1, closest1) ?
+                        "cord_signal" : "cord_control"),
+                    oc, (obj_issignaloutlet(ob1, closest1) ?
+                        "signal" : "control"));
                 canvas_dirty(x, 1);
                 canvas_setundo(x, canvas_undo_connect,
                     canvas_undo_set_connect(x, 
@@ -2539,9 +2550,12 @@ void canvas_connect(t_canvas *x, t_float
     if (!(oc = obj_connect(objsrc, outno, objsink, inno))) goto bad;
     if (glist_isvisible(x))
     {
-        sys_vgui(".x%lx.c create line %d %d %d %d -width %d -tags [list l%lx cord]\n",
+        sys_vgui(".x%lx.c create line %d %d %d %d -width %d \
+            -fill $::pd_colors(%s) -tags [list l%lx %s cord]\n",
             glist_getcanvas(x), 0, 0, 0, 0,
-            (obj_issignaloutlet(objsrc, outno) ? 2 : 1),oc);
+            (obj_issignaloutlet(objsrc, outno) ? 2 : 1),
+            (obj_issignaloutlet(objsrc, outno) ? "cord_signal" : "cord_control"),
+            oc, (obj_issignaloutlet(objsrc, outno) ? "signal" : "control"));
         canvas_fixlinesfor(x, objsrc);
     }
     return;
diff -rupN newpd/pd-0.45-0/src/g_graph.c pd-0.45-0/src/g_graph.c
--- newpd/pd-0.45-0/src/g_graph.c	2013-08-09 18:17:07.000000000 -0400
+++ pd-0.45-0/src/g_graph.c	2013-08-27 12:37:35.798359149 -0400
@@ -722,9 +722,10 @@ static void graph_vis(t_gobj *gr, t_glis
             
             /* draw a rectangle around the graph */
         sys_vgui(".x%lx.c create line\
-            %d %d %d %d %d %d %d %d %d %d -tags [list %s graph]\n",
-            glist_getcanvas(x->gl_owner),
-            x1, y1, x1, y2, x2, y2, x2, y1, x1, y1, tag);
+            %d %d %d %d %d %d %d %d %d %d -tags [list %s graph] \
+            -fill $::pd_colors(box_border)\n",
+                glist_getcanvas(x->gl_owner),
+                x1, y1, x1, y2, x2, y2, x2, y1, x1, y1, tag);
         
             /* if there's just one "garray" in the graph, write its name
                 along the top */
@@ -734,7 +735,8 @@ static void graph_vis(t_gobj *gr, t_glis
         {
             i -= sys_fontheight(glist_getfont(x));
             sys_vgui(".x%lx.c create text %d %d -text {%s} -anchor nw\
-             -font {{%s} -%d %s} -tags [list %s label graph]\n",
+             -font {{%s} -%d %s} -tags [list %s label graph] \
+             -fill $::pd_colors(text)\n",
              (long)glist_getcanvas(x),  x1, i, arrayname->s_name, sys_font,
                 sys_hostfontsize(glist_getfont(x)), sys_fontweight, tag);
         }
@@ -752,11 +754,11 @@ static void graph_vis(t_gobj *gr, t_glis
                     f += x->gl_xtick.k_inc)
             {
                 int tickpix = (i % x->gl_xtick.k_lperb ? 2 : 4);
-                sys_vgui(".x%lx.c create line %d %d %d %d -tags [list %s graph]\n",
+                sys_vgui(".x%lx.c create line %d %d %d %d -tags [list %s graph] -fill blue \n",
                     glist_getcanvas(x->gl_owner),
                     (int)glist_xtopixels(x, f), (int)upix,
                     (int)glist_xtopixels(x, f), (int)upix - tickpix, tag);
-                sys_vgui(".x%lx.c create line %d %d %d %d -tags [list %s graph]\n",
+                sys_vgui(".x%lx.c create line %d %d %d %d -tags [list %s graph] -fill blue \n",
                     glist_getcanvas(x->gl_owner),
                     (int)glist_xtopixels(x, f), (int)lpix,
                     (int)glist_xtopixels(x, f), (int)lpix + tickpix, tag);
@@ -766,7 +768,7 @@ static void graph_vis(t_gobj *gr, t_glis
                     i++, f -= x->gl_xtick.k_inc)
             {
                 int tickpix = (i % x->gl_xtick.k_lperb ? 2 : 4);
-                sys_vgui(".x%lx.c create line %d %d %d %d -tags [list %s graph]\n",
+                sys_vgui(".x%lx.c create line %d %d %d %d -tags [list %s graph] -fill blue \n",
                     glist_getcanvas(x->gl_owner),
                     (int)glist_xtopixels(x, f), (int)upix,
                     (int)glist_xtopixels(x, f), (int)upix - tickpix, tag);
@@ -943,10 +945,11 @@ static void graph_select(t_gobj *z, t_gl
         t_rtext *y = glist_findrtext(glist, &x->gl_obj);
         if (canvas_showtext(x))
             rtext_select(y, state);
-        sys_vgui(".x%lx.c itemconfigure %sR -fill %s\n", glist, 
-        rtext_gettag(y), (state? "blue" : "black"));
-        sys_vgui(".x%lx.c itemconfigure graph%lx -fill %s\n",
-            glist_getcanvas(glist), z, (state? "blue" : "black"));
+        sys_vgui(".x%lx.c itemconfigure %s -fill $::pd_colors(%s)\n", glist, 
+        rtext_gettag(y), (state? "selected" : "box_border"));
+        sys_vgui(".x%lx.c itemconfigure graph%lx&&label \
+            -fill $::pd_colors(%s)\n",
+                glist_getcanvas(glist), z, (state? "selected" : "text"));
     }
 }
 
diff -rupN newpd/pd-0.45-0/src/g_hdial.c pd-0.45-0/src/g_hdial.c
--- newpd/pd-0.45-0/src/g_hdial.c	2013-08-07 16:29:37.000000000 -0400
+++ pd-0.45-0/src/g_hdial.c	2013-08-27 12:37:35.798359149 -0400
@@ -60,7 +60,9 @@ void hradio_draw_new(t_hradio *x, t_glis
 
     for(i=0; i<n; i++)
     {
-        sys_vgui(".x%lx.c create rectangle %d %d %d %d -fill #%6.6x -tags %lxBASE%d\n",
+        sys_vgui(".x%lx.c create rectangle %d %d %d %d -fill #%6.6x \
+            -outline $::pd_colors(iemgui_border) \
+            -tags {%lxBASE%d iemgui border}\n",
                  canvas, xx11, yy11, xx11+dx, yy12,
                  x->x_gui.x_bcol, x, i);
         sys_vgui(".x%lx.c create rectangle %d %d %d %d -fill #%6.6x -outline #%6.6x -tags %lxBUT%d\n",
@@ -73,7 +75,7 @@ void hradio_draw_new(t_hradio *x, t_glis
         x->x_drawn = x->x_on;
     }
     sys_vgui(".x%lx.c create text %d %d -text {%s} -anchor w \
-             -font {{%s} -%d %s} -fill #%6.6x -tags [list %lxLABEL label text]\n",
+             -font {{%s} -%d %s} -fill #%6.6x -tags [list %lxLABEL iemgui label text]\n",
              canvas, xx11b+x->x_gui.x_ldx, yy11+x->x_gui.x_ldy,
              strcmp(x->x_gui.x_lab->s_name, "empty")?x->x_gui.x_lab->s_name:"",
              x->x_gui.x_font, x->x_gui.x_fontsize, sys_fontweight,
@@ -141,14 +143,15 @@ void hradio_draw_config(t_hradio* x, t_g
     t_canvas *canvas=glist_getcanvas(glist);
     int n=x->x_number, i;
 
-    sys_vgui(".x%lx.c itemconfigure %lxLABEL -font {{%s} -%d %s} -fill #%6.6x -text {%s} \n",
+    sys_vgui(".x%lx.c itemconfigure %lxLABEL -font {{%s} -%d %s} -fill %s -text {%s} \n",
              canvas, x, x->x_gui.x_font, x->x_gui.x_fontsize, sys_fontweight,
-             x->x_gui.x_fsf.x_selected?IEM_GUI_COLOR_SELECTED:x->x_gui.x_lcol,
+             x->x_gui.x_fsf.x_selected?IEM_GUI_COLOR_SELECTED:iemgui_intcoltostring(x->x_gui.x_lcol),
              strcmp(x->x_gui.x_lab->s_name, "empty")?x->x_gui.x_lab->s_name:"");
     for(i=0; i<n; i++)
     {
-        sys_vgui(".x%lx.c itemconfigure %lxBASE%d -fill #%6.6x\n", canvas, x, i,
-                 x->x_gui.x_bcol);
+        sys_vgui(".x%lx.c itemconfigure %lxBASE%d -fill #%6.6x \
+            -outline $::pd_colors(iemgui_border)\n",
+                canvas, x, i, x->x_gui.x_bcol);
         sys_vgui(".x%lx.c itemconfigure %lxBUT%d -fill #%6.6x -outline #%6.6x\n", canvas, x, i,
                  (x->x_on==i)?x->x_gui.x_fcol:x->x_gui.x_bcol,
                  (x->x_on==i)?x->x_gui.x_fcol:x->x_gui.x_bcol);
@@ -187,16 +190,16 @@ void hradio_draw_select(t_hradio* x, t_g
     {
         for(i=0; i<n; i++)
         {
-            sys_vgui(".x%lx.c itemconfigure %lxBASE%d -outline #%6.6x\n", canvas, x, i,
+            sys_vgui(".x%lx.c itemconfigure %lxBASE%d -outline %s\n", canvas, x, i,
                      IEM_GUI_COLOR_SELECTED);
         }
-        sys_vgui(".x%lx.c itemconfigure %lxLABEL -fill #%6.6x\n", canvas, x, IEM_GUI_COLOR_SELECTED);
+        sys_vgui(".x%lx.c itemconfigure %lxLABEL -fill %s\n", canvas, x, IEM_GUI_COLOR_SELECTED);
     }
     else
     {
         for(i=0; i<n; i++)
         {
-            sys_vgui(".x%lx.c itemconfigure %lxBASE%d -outline #%6.6x\n", canvas, x, i,
+            sys_vgui(".x%lx.c itemconfigure %lxBASE%d -outline %s\n", canvas, x, i,
                      IEM_GUI_COLOR_NORMAL);
         }
         sys_vgui(".x%lx.c itemconfigure %lxLABEL -fill #%6.6x\n", canvas, x,
diff -rupN newpd/pd-0.45-0/src/g_hslider.c pd-0.45-0/src/g_hslider.c
--- newpd/pd-0.45-0/src/g_hslider.c	2013-08-07 16:29:37.000000000 -0400
+++ pd-0.45-0/src/g_hslider.c	2013-08-27 12:37:35.802359065 -0400
@@ -67,7 +67,8 @@ static void hslider_draw_new(t_hslider *
     int r = xpos + (x->x_val + 50)/100;
     t_canvas *canvas=glist_getcanvas(glist);
 
-    sys_vgui(".x%lx.c create rectangle %d %d %d %d -fill #%6.6x -tags %lxBASE\n",
+    sys_vgui(".x%lx.c create rectangle %d %d %d %d -fill #%6.6x \
+        -outline $::pd_colors(iemgui_border) -tags {%lxBASE iemgui border}\n",
              canvas, xpos-3, ypos,
              xpos + x->x_gui.x_w+2, ypos + x->x_gui.x_h,
              x->x_gui.x_bcol, x);
@@ -75,7 +76,7 @@ static void hslider_draw_new(t_hslider *
              canvas, r, ypos+1, r,
              ypos + x->x_gui.x_h, x->x_gui.x_fcol, x);
     sys_vgui(".x%lx.c create text %d %d -text {%s} -anchor w \
-             -font {{%s} -%d %s} -fill #%6.6x -tags [list %lxLABEL label text]\n",
+             -font {{%s} -%d %s} -fill #%6.6x -tags [list %lxLABEL iemgui label text]\n",
              canvas, xpos+x->x_gui.x_ldx,
              ypos+x->x_gui.x_ldy,
              strcmp(x->x_gui.x_lab->s_name, "empty")?x->x_gui.x_lab->s_name:"",
@@ -136,9 +137,9 @@ static void hslider_draw_config(t_hslide
 {
     t_canvas *canvas=glist_getcanvas(glist);
 
-    sys_vgui(".x%lx.c itemconfigure %lxLABEL -font {{%s} -%d %s} -fill #%6.6x -text {%s} \n",
+    sys_vgui(".x%lx.c itemconfigure %lxLABEL -font {{%s} -%d %s} -fill %s -text {%s} \n",
              canvas, x, x->x_gui.x_font, x->x_gui.x_fontsize, sys_fontweight,
-             x->x_gui.x_fsf.x_selected?IEM_GUI_COLOR_SELECTED:x->x_gui.x_lcol,
+             x->x_gui.x_fsf.x_selected?IEM_GUI_COLOR_SELECTED:iemgui_intcoltostring(x->x_gui.x_lcol),
              strcmp(x->x_gui.x_lab->s_name, "empty")?x->x_gui.x_lab->s_name:"");
     sys_vgui(".x%lx.c itemconfigure %lxKNOB -fill #%6.6x\n", canvas, x, x->x_gui.x_fcol);
     sys_vgui(".x%lx.c itemconfigure %lxBASE -fill #%6.6x\n", canvas, x, x->x_gui.x_bcol);
@@ -170,12 +171,12 @@ static void hslider_draw_select(t_hslide
 
     if(x->x_gui.x_fsf.x_selected)
     {
-        sys_vgui(".x%lx.c itemconfigure %lxBASE -outline #%6.6x\n", canvas, x, IEM_GUI_COLOR_SELECTED);
-        sys_vgui(".x%lx.c itemconfigure %lxLABEL -fill #%6.6x\n", canvas, x, IEM_GUI_COLOR_SELECTED);
+        sys_vgui(".x%lx.c itemconfigure %lxBASE -outline %s\n", canvas, x, IEM_GUI_COLOR_SELECTED);
+        sys_vgui(".x%lx.c itemconfigure %lxLABEL -fill %s\n", canvas, x, IEM_GUI_COLOR_SELECTED);
     }
     else
     {
-        sys_vgui(".x%lx.c itemconfigure %lxBASE -outline #%6.6x\n", canvas, x, IEM_GUI_COLOR_NORMAL);
+        sys_vgui(".x%lx.c itemconfigure %lxBASE -outline %s\n", canvas, x, IEM_GUI_COLOR_NORMAL);
         sys_vgui(".x%lx.c itemconfigure %lxLABEL -fill #%6.6x\n", canvas, x, x->x_gui.x_lcol);
     }
 }
diff -rupN newpd/pd-0.45-0/src/g_mycanvas.c pd-0.45-0/src/g_mycanvas.c
--- newpd/pd-0.45-0/src/g_mycanvas.c	2013-08-07 16:29:37.000000000 -0400
+++ pd-0.45-0/src/g_mycanvas.c	2013-08-27 12:37:35.802359065 -0400
@@ -39,12 +39,13 @@ void my_canvas_draw_new(t_my_canvas *x,
              canvas, xpos, ypos,
              xpos + x->x_vis_w, ypos + x->x_vis_h,
              x->x_gui.x_bcol, x->x_gui.x_bcol, x);
-    sys_vgui(".x%lx.c create rectangle %d %d %d %d -outline #%6.6x -tags %lxBASE\n",
+    sys_vgui(".x%lx.c create rectangle %d %d %d %d \
+        -outline #%6.6x -tags {%lxBASE iemgui border}\n",
              canvas, xpos, ypos,
              xpos + x->x_gui.x_w, ypos + x->x_gui.x_h,
              x->x_gui.x_bcol, x);
     sys_vgui(".x%lx.c create text %d %d -text {%s} -anchor w \
-             -font {{%s} -%d %s} -fill #%6.6x -tags [list %lxLABEL label text]\n",
+             -font {{%s} -%d %s} -fill #%6.6x -tags [list %lxLABEL iemgui label text]\n",
              canvas, xpos+x->x_gui.x_ldx, ypos+x->x_gui.x_ldy,
              strcmp(x->x_gui.x_lab->s_name, "empty")?x->x_gui.x_lab->s_name:"",
              x->x_gui.x_font, x->x_gui.x_fontsize, sys_fontweight,
@@ -83,8 +84,8 @@ void my_canvas_draw_config(t_my_canvas*
 
     sys_vgui(".x%lx.c itemconfigure %lxRECT -fill #%6.6x -outline #%6.6x\n", canvas, x,
              x->x_gui.x_bcol, x->x_gui.x_bcol);
-    sys_vgui(".x%lx.c itemconfigure %lxBASE -outline #%6.6x\n", canvas, x,
-             x->x_gui.x_fsf.x_selected?IEM_GUI_COLOR_SELECTED:x->x_gui.x_bcol);
+    sys_vgui(".x%lx.c itemconfigure %lxBASE -outline %s\n", canvas, x,
+             x->x_gui.x_fsf.x_selected?IEM_GUI_COLOR_SELECTED:iemgui_intcoltostring(x->x_gui.x_bcol));
     sys_vgui(".x%lx.c itemconfigure %lxLABEL -font {{%s} -%d %s} -fill #%6.6x -text {%s} \n",
              canvas, x, x->x_gui.x_font, x->x_gui.x_fontsize, sys_fontweight,
              x->x_gui.x_lcol,
@@ -97,7 +98,7 @@ void my_canvas_draw_select(t_my_canvas*
 
     if(x->x_gui.x_fsf.x_selected)
     {
-        sys_vgui(".x%lx.c itemconfigure %lxBASE -outline #%6.6x\n", canvas, x, IEM_GUI_COLOR_SELECTED);
+        sys_vgui(".x%lx.c itemconfigure %lxBASE -outline %s\n", canvas, x, IEM_GUI_COLOR_SELECTED);
     }
     else
     {
